﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;

namespace TestProgressBar
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraProgressBar3.DrawFilter = new FormBasedPartValueDrawFilter(this);
            //ultraGrid1.DrawFilter = new FormBasedPartValueDrawFilter(this);
            myProgressBarControl1.DrawFilter = new ControlBasedPartValueDrawFilter();
        }

        #region Implementation of ITaskProgress

        public int Selected
        {
            get { return trackBarValue.Value; }
        }

        public int Sucesseded
        {
            get { return trackBar1.Value; }
        }

        public int Rejected
        {
            get { return trackBar2.Value; }
        }

        #endregion

        private void BindGridData()
        {
            BindingList<ProgressBarData> list = new BindingList<ProgressBarData>();
            list.Add(new ProgressBarData { Value = 10, Data = new ComplexData { Selected = 80, Rejected = 10, Sucesseded = 15 } });
            list.Add(new ProgressBarData { Value = 20 });
            list.Add(new ProgressBarData { Value = 10 });
            list.Add(new ProgressBarData { Value = 20 });
            list.Add(new ProgressBarData { Value = 30 });
            list.Add(new ProgressBarData { Value = 40 });

            ultraGrid1.DataSource = list;
        }

        private void UpdateFillAppearance()
        {
            ultraProgressBar2.FillAppearance.BackColor = Color.Red;
            ultraProgressBar2.FillAppearance.BackColor2 = Color.Green;
            int percent = (ultraProgressBar2.Value / ultraProgressBar2.Maximum * 100);
            if (percent < 50)
            {
                ultraProgressBar2.FillAppearance.BackGradientStyle = GradientStyle.GlassLeft20;
            }
            else if (percent < 70)
            {
                ultraProgressBar2.FillAppearance.BackGradientStyle = GradientStyle.GlassLeft37;
            }
            else if (percent < 90)
            {
                ultraProgressBar2.FillAppearance.BackGradientStyle = GradientStyle.GlassLeft37;
            }
            else
            {
                ultraProgressBar2.FillAppearance.BackGradientStyle = GradientStyle.None;
            }


        }

        private void trackBarValue_ValueChanged(object sender, EventArgs e)
        {
            ultraProgressBar1.Value = trackBarValue.Value;
            ultraProgressBar2.Value = trackBarValue.Value;
            ultraProgressBar3.Value = trackBarValue.Value;


            UpdateFillAppearance();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            uiElementViewerDialog1.Show();
            BindGridData();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            //e.Layout.Bands[0].Columns[0].EditorComponent = ultraProgressBar3;
            e.Layout.Bands[0].Columns[1].EditorComponent = ultraControlContainerEditor1;
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            //UltraProgressBar bar = new UltraProgressBar();
            //bar.Maximum = 100;
            //e.Row.Cells[0].EditorComponent = bar;
        }
    }
}
